export interface User {
  id: number;
  username: string;
  email: string;
  avatar: string;
  department_id: null;
  creator_id: number;
  status: number;
  login_ip: string;
  login_at: number;
  created_at: string;
  updated_at: string;
  deleted_at: Date;
  permissions: Permission[];
  roles: Role[];
  jobs: Job[];
}

export interface Permission {
  id: number;
  parent_id: number;
  permission_name: string;
  route: string;
  icon: string;
  module: PermissionModule;
  permission_mark: string;
  component: string;
  redirect: null | string;
  keepalive: number;
  type: number;
  hidden: boolean;
  sort: number;
  active_menu: string;
  creator_id: number;
  created_at: string;
  updated_at: string;
}

export enum PermissionModule {
  Lesson = "lesson",
  Permissions = "permissions",
  User = "user",
}

export interface Job {
  id: number;
  job_name: string;
  coding: string;
  status: number;
  sort: number;
  description: string;
  creator_id: number;
  created_at: string;
  updated_at: string;
  pivot: JobPivot;
}

export interface JobPivot {
  user_id: number;
  job_id: number;
}

export interface Role {
  id: number;
  role_name: string;
  identify: string;
  parent_id: number;
  description: string;
  data_range: number;
  creator_id: number;
  created_at: string;
  updated_at: string;
  pivot: RolePivot;
}

export interface RolePivot {
  user_id: number;
  role_id: number;
}
